function fdfkConfirmOptions() {

  var minforksize = document.getElementById('fdfk-dropdown-min-fork-size').selectedItem.label;
  var maxforks = document.getElementById('fdfk-dropdown-max-forks').selectedItem.label;

  Components.classes["@mozilla.org/observer-service;1"]
            .getService(Components.interfaces.nsIObserverService)
            .notifyObservers(null, "forwardfork:minforksize", minforksize);

  Components.classes["@mozilla.org/observer-service;1"]
            .getService(Components.interfaces.nsIObserverService)
            .notifyObservers(null, "forwardfork:maxforks", maxforks);

  return true;
}

function fdfkCancelOptions() {

  return true;
}

function fdfkOnOptionsLoad() {

  var totalForks = 1;
  var minPagesPerFork = 1;
  var maxTotalForks = 6;
  var maxMinPagesPerFork = 4;

  var prefs = Components.classes["@mozilla.org/preferences-service;1"].
              getService(Components.interfaces.nsIPrefService);
  prefs = prefs.getBranch("forwardfork.preferences.");

  if (prefs.getPrefType("maximumforks") == prefs.PREF_INT) {
    totalForks = prefs.getIntPref("maximumforks");
  }

  if (prefs.getPrefType("minimumforksize") == prefs.PREF_INT) {
    minPagesPerFork = prefs.getIntPref("minimumforksize");
  }

  var minForkSize = document.getElementById("fdfk-dropdown-min-fork-size");
  var maxForks = document.getElementById("fdfk-dropdown-max-forks");

  fdfkBuildDropDown(minForkSize,'minimumforksize',4);
  fdfkBuildDropDown(maxForks,'maximumforks',6);
}

function fdfkBuildDropDown(parent, pref, max) {

  var prefs = Components.classes["@mozilla.org/preferences-service;1"].
              getService(Components.interfaces.nsIPrefService);
  var selected = 1;
  var menupopup = document.createElement("menupopup");

  prefs = prefs.getBranch("forwardfork.preferences.");

  if (pref == "maximumforks") {
    if (prefs.getPrefType("maximumforks") == prefs.PREF_INT) {
      selected = prefs.getIntPref("maximumforks");
    }
  } else if (pref == "minimumforksize") {
    if (prefs.getPrefType("minimumforksize") == prefs.PREF_INT) {
      selected = prefs.getIntPref("minimumforksize");
    }
  }
  for (var i=1; i<=max; ++i) {
    var menuitem = document.createElement("menuitem");
    menuitem.setAttribute("label", i);
    if (i == selected) menuitem.setAttribute("selected", true);
    menupopup.appendChild(menuitem);
  }

  parent.setAttribute("label",selected);
  parent.appendChild(menupopup);
  parent.selectedIndex = selected-1;

  return true;
}

// Ready, set, go!!
fdfkOnOptionsLoad();
